"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCustomFrame = exports.HideSequence = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importStar(require("react"));
const use_current_frame_1 = require("./use-current-frame");
const context = react_1.default.createContext(null);
const HideSequence = ({ from, durationInFrames, children }) => {
    var _a, _b, _c;
    const parent = react_1.default.useContext(context);
    const frame = (0, use_current_frame_1.useCurrentFrame)();
    const actualFrame = (_a = parent === null || parent === void 0 ? void 0 : parent.frame) !== null && _a !== void 0 ? _a : frame;
    const cascadedFrame = actualFrame + ((_b = parent === null || parent === void 0 ? void 0 : parent.from) !== null && _b !== void 0 ? _b : 0);
    const visible = cascadedFrame >= from &&
        cascadedFrame < from + durationInFrames &&
        ((_c = parent === null || parent === void 0 ? void 0 : parent.visible) !== null && _c !== void 0 ? _c : true);
    const value = (0, react_1.useMemo)(() => {
        return {
            from,
            durationInFrames,
            visible,
            frame: cascadedFrame,
        };
    }, [cascadedFrame, durationInFrames, from, visible]);
    return (0, jsx_runtime_1.jsx)(context.Provider, { value: value, children: children });
};
exports.HideSequence = HideSequence;
const useCustomFrame = () => {
    const ctx = react_1.default.useContext(context);
    const frame = (0, use_current_frame_1.useCurrentFrame)();
    if (!ctx) {
        return frame;
    }
    return ctx.frame;
};
exports.useCustomFrame = useCustomFrame;
